#!/usr/bin/env python
#Author: Mark Feineigle
#Create Date: 2018/03/14
#Last Modify: 2018/03/14
# Mastering Machine Learning with Python in Six Steps page 294

import pandas as pd
from sklearn.ensemble import GradientBoostingClassifier 
from sklearn.datasets import load_digits

data = load_digits()
df = pd.DataFrame(data.data) #NOTE don't know how to load the data... This book is SHIT
print df[:10]
#df= pd.read_csv('Data/digit.csv') 
X = df.ix[:,1:17].values 
y = df['target'].values 
# evaluate the model by splitting into train and test sets 
X_train, X_test, y_train, y_test = train_test_split(X, y, test_size=0.2, random_state=2017) 
kfold = cross_validation.StratifiedKFold(y=y_train, n_folds=5, random_state=2017) 
num_trees = 10
clf_GBT = GradientBoostingClassifier(n_estimators=num_trees,
                                     learning_rate=0.1, 
                                     max_depth=3,
                                     random_state=2017).fit(X_train, y_train) 
results = cross_validation.cross_val_score(clf_GBT, X_train, y_train, cv=kfold) 
print "\nGradient Boosting - Train : ", metrics.accuracy_score(clf_GBT.predict(X_train), y_train) 
print "Gradient Boosting - Test : ", metrics.accuracy_score(clf_GBT.predict(X_test), y_test) 

# Let's predict for the letter 'T' and understand how the
# prediction accuracy changes in each boosting iteration 
X_valid= (2,8,3,5,1,8,13,0,6,6,10,8,0,8,0,8) 
print "Predicted letter: ", clf_GBT.predict(X_valid) 
# Staged prediction will give the predicted probability for each boosting iteration 
stage_preds = list(clf_GBT.staged_predict_proba(X_valid)) 
final_preds = clf_GBT.predict_proba(X_valid) 
# Plot 
x = range(1,27) 
label = np.unique(df['lettr']) 
plt.figure(figsize=(10,3)) 
plt.subplot(131) 
plt.bar(x, stage_preds[0][0], align='center') 
plt.xticks(x, label) 
plt.xlabel('Label') 
plt.ylabel('Prediction Probability') 
plt.title('Round One') 
plt.autoscale() 
plt.subplot(132) 
plt.bar(x, stage_preds[5][0],align='center') 
plt.xticks(x, label) 
plt.xlabel('Label') 
plt.ylabel('Prediction Probability') 
plt.title('Round Five')
plt.autoscale() 
plt.subplot(133) 
plt.bar(x, stage_preds[9][0],align='center') 
plt.xticks(x, label) 
plt.autoscale() 
plt.xlabel('Label') 
plt.ylabel('Prediction Probability') 
plt.title('Round Ten') 
plt.tight_layout() 
plt.show()
